<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ActivityLocationType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackActivityLocationType extends AbstractStructBase
{
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackAddressType
     */
    public $Address;
    /**
     * The TransportFacility
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackTransportFacilityType
     */
    public $TransportFacility;
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The SignedForByName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SignedForByName;
    /**
     * Constructor method for ActivityLocationType
     * @uses Ups_trackActivityLocationType::setAddress()
     * @uses Ups_trackActivityLocationType::setTransportFacility()
     * @uses Ups_trackActivityLocationType::setCode()
     * @uses Ups_trackActivityLocationType::setDescription()
     * @uses Ups_trackActivityLocationType::setSignedForByName()
     * @param \Ups_track\UPStrackStruct\Ups_trackAddressType $address
     * @param \Ups_track\UPStrackStruct\Ups_trackTransportFacilityType $transportFacility
     * @param string $code
     * @param string $description
     * @param string $signedForByName
     */
    public function __construct(\Ups_track\UPStrackStruct\Ups_trackAddressType $address = null, \Ups_track\UPStrackStruct\Ups_trackTransportFacilityType $transportFacility = null, $code = null, $description = null, $signedForByName = null)
    {
        $this
            ->setAddress($address)
            ->setTransportFacility($transportFacility)
            ->setCode($code)
            ->setDescription($description)
            ->setSignedForByName($signedForByName);
    }
    /**
     * Get Address value
     * @return \Ups_track\UPStrackStruct\Ups_trackAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Ups_track\UPStrackStruct\Ups_trackAddressType $address
     * @return \Ups_track\UPStrackStruct\Ups_trackActivityLocationType
     */
    public function setAddress(\Ups_track\UPStrackStruct\Ups_trackAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get TransportFacility value
     * @return \Ups_track\UPStrackStruct\Ups_trackTransportFacilityType|null
     */
    public function getTransportFacility()
    {
        return $this->TransportFacility;
    }
    /**
     * Set TransportFacility value
     * @param \Ups_track\UPStrackStruct\Ups_trackTransportFacilityType $transportFacility
     * @return \Ups_track\UPStrackStruct\Ups_trackActivityLocationType
     */
    public function setTransportFacility(\Ups_track\UPStrackStruct\Ups_trackTransportFacilityType $transportFacility = null)
    {
        $this->TransportFacility = $transportFacility;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Ups_track\UPStrackStruct\Ups_trackActivityLocationType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Ups_track\UPStrackStruct\Ups_trackActivityLocationType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get SignedForByName value
     * @return string|null
     */
    public function getSignedForByName()
    {
        return $this->SignedForByName;
    }
    /**
     * Set SignedForByName value
     * @param string $signedForByName
     * @return \Ups_track\UPStrackStruct\Ups_trackActivityLocationType
     */
    public function setSignedForByName($signedForByName = null)
    {
        // validation for constraint: string
        if (!is_null($signedForByName) && !is_string($signedForByName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signedForByName, true), gettype($signedForByName)), __LINE__);
        }
        $this->SignedForByName = $signedForByName;
        return $this;
    }
}
