<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CODType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackCODType extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackAmountType
     */
    public $Amount;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackCODStatusType
     */
    public $Status;
    /**
     * The ControlNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ControlNumber;
    /**
     * Constructor method for CODType
     * @uses Ups_trackCODType::setAmount()
     * @uses Ups_trackCODType::setStatus()
     * @uses Ups_trackCODType::setControlNumber()
     * @param \Ups_track\UPStrackStruct\Ups_trackAmountType $amount
     * @param \Ups_track\UPStrackStruct\Ups_trackCODStatusType $status
     * @param string $controlNumber
     */
    public function __construct(\Ups_track\UPStrackStruct\Ups_trackAmountType $amount = null, \Ups_track\UPStrackStruct\Ups_trackCODStatusType $status = null, $controlNumber = null)
    {
        $this
            ->setAmount($amount)
            ->setStatus($status)
            ->setControlNumber($controlNumber);
    }
    /**
     * Get Amount value
     * @return \Ups_track\UPStrackStruct\Ups_trackAmountType|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param \Ups_track\UPStrackStruct\Ups_trackAmountType $amount
     * @return \Ups_track\UPStrackStruct\Ups_trackCODType
     */
    public function setAmount(\Ups_track\UPStrackStruct\Ups_trackAmountType $amount = null)
    {
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get Status value
     * @return \Ups_track\UPStrackStruct\Ups_trackCODStatusType|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param \Ups_track\UPStrackStruct\Ups_trackCODStatusType $status
     * @return \Ups_track\UPStrackStruct\Ups_trackCODType
     */
    public function setStatus(\Ups_track\UPStrackStruct\Ups_trackCODStatusType $status = null)
    {
        $this->Status = $status;
        return $this;
    }
    /**
     * Get ControlNumber value
     * @return string|null
     */
    public function getControlNumber()
    {
        return $this->ControlNumber;
    }
    /**
     * Set ControlNumber value
     * @param string $controlNumber
     * @return \Ups_track\UPStrackStruct\Ups_trackCODType
     */
    public function setControlNumber($controlNumber = null)
    {
        // validation for constraint: string
        if (!is_null($controlNumber) && !is_string($controlNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($controlNumber, true), gettype($controlNumber)), __LINE__);
        }
        $this->ControlNumber = $controlNumber;
        return $this;
    }
}
