<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarrierActivityInformationType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackCarrierActivityInformationType extends AbstractStructBase
{
    /**
     * The CarrierId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CarrierId;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Arrival
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackDateTimeType
     */
    public $Arrival;
    /**
     * The Departure
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackDateTimeType
     */
    public $Departure;
    /**
     * The OriginPort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $OriginPort;
    /**
     * The DestinationPort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DestinationPort;
    /**
     * Constructor method for CarrierActivityInformationType
     * @uses Ups_trackCarrierActivityInformationType::setCarrierId()
     * @uses Ups_trackCarrierActivityInformationType::setDescription()
     * @uses Ups_trackCarrierActivityInformationType::setStatus()
     * @uses Ups_trackCarrierActivityInformationType::setArrival()
     * @uses Ups_trackCarrierActivityInformationType::setDeparture()
     * @uses Ups_trackCarrierActivityInformationType::setOriginPort()
     * @uses Ups_trackCarrierActivityInformationType::setDestinationPort()
     * @param string $carrierId
     * @param string $description
     * @param string $status
     * @param \Ups_track\UPStrackStruct\Ups_trackDateTimeType $arrival
     * @param \Ups_track\UPStrackStruct\Ups_trackDateTimeType $departure
     * @param string $originPort
     * @param string $destinationPort
     */
    public function __construct($carrierId = null, $description = null, $status = null, \Ups_track\UPStrackStruct\Ups_trackDateTimeType $arrival = null, \Ups_track\UPStrackStruct\Ups_trackDateTimeType $departure = null, $originPort = null, $destinationPort = null)
    {
        $this
            ->setCarrierId($carrierId)
            ->setDescription($description)
            ->setStatus($status)
            ->setArrival($arrival)
            ->setDeparture($departure)
            ->setOriginPort($originPort)
            ->setDestinationPort($destinationPort);
    }
    /**
     * Get CarrierId value
     * @return string|null
     */
    public function getCarrierId()
    {
        return $this->CarrierId;
    }
    /**
     * Set CarrierId value
     * @param string $carrierId
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setCarrierId($carrierId = null)
    {
        // validation for constraint: string
        if (!is_null($carrierId) && !is_string($carrierId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierId, true), gettype($carrierId)), __LINE__);
        }
        $this->CarrierId = $carrierId;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Arrival value
     * @return \Ups_track\UPStrackStruct\Ups_trackDateTimeType|null
     */
    public function getArrival()
    {
        return $this->Arrival;
    }
    /**
     * Set Arrival value
     * @param \Ups_track\UPStrackStruct\Ups_trackDateTimeType $arrival
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setArrival(\Ups_track\UPStrackStruct\Ups_trackDateTimeType $arrival = null)
    {
        $this->Arrival = $arrival;
        return $this;
    }
    /**
     * Get Departure value
     * @return \Ups_track\UPStrackStruct\Ups_trackDateTimeType|null
     */
    public function getDeparture()
    {
        return $this->Departure;
    }
    /**
     * Set Departure value
     * @param \Ups_track\UPStrackStruct\Ups_trackDateTimeType $departure
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setDeparture(\Ups_track\UPStrackStruct\Ups_trackDateTimeType $departure = null)
    {
        $this->Departure = $departure;
        return $this;
    }
    /**
     * Get OriginPort value
     * @return string|null
     */
    public function getOriginPort()
    {
        return $this->OriginPort;
    }
    /**
     * Set OriginPort value
     * @param string $originPort
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setOriginPort($originPort = null)
    {
        // validation for constraint: string
        if (!is_null($originPort) && !is_string($originPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originPort, true), gettype($originPort)), __LINE__);
        }
        $this->OriginPort = $originPort;
        return $this;
    }
    /**
     * Get DestinationPort value
     * @return string|null
     */
    public function getDestinationPort()
    {
        return $this->DestinationPort;
    }
    /**
     * Set DestinationPort value
     * @param string $destinationPort
     * @return \Ups_track\UPStrackStruct\Ups_trackCarrierActivityInformationType
     */
    public function setDestinationPort($destinationPort = null)
    {
        // validation for constraint: string
        if (!is_null($destinationPort) && !is_string($destinationPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destinationPort, true), gettype($destinationPort)), __LINE__);
        }
        $this->DestinationPort = $destinationPort;
        return $this;
    }
}
