<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackDocumentType extends AbstractStructBase
{
    /**
     * The Type
     * @var \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType
     */
    public $Type;
    /**
     * The Content
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Content;
    /**
     * The Format
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType
     */
    public $Format;
    /**
     * Constructor method for DocumentType
     * @uses Ups_trackDocumentType::setType()
     * @uses Ups_trackDocumentType::setContent()
     * @uses Ups_trackDocumentType::setFormat()
     * @param \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $type
     * @param string $content
     * @param \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $format
     */
    public function __construct(\Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $type = null, $content = null, \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $format = null)
    {
        $this
            ->setType($type)
            ->setContent($content)
            ->setFormat($format);
    }
    /**
     * Get Type value
     * @return \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $type
     * @return \Ups_track\UPStrackStruct\Ups_trackDocumentType
     */
    public function setType(\Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Content value
     * @return string|null
     */
    public function getContent()
    {
        return $this->Content;
    }
    /**
     * Set Content value
     * @param string $content
     * @return \Ups_track\UPStrackStruct\Ups_trackDocumentType
     */
    public function setContent($content = null)
    {
        // validation for constraint: string
        if (!is_null($content) && !is_string($content)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($content, true), gettype($content)), __LINE__);
        }
        $this->Content = $content;
        return $this;
    }
    /**
     * Get Format value
     * @return \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType|null
     */
    public function getFormat()
    {
        return $this->Format;
    }
    /**
     * Set Format value
     * @param \Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $format
     * @return \Ups_track\UPStrackStruct\Ups_trackDocumentType
     */
    public function setFormat(\Ups_track\UPStrackStruct\Ups_trackCommonCodeDescriptionType $format = null)
    {
        $this->Format = $format;
        return $this;
    }
}
