<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PreauthorizedReturnInformationType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackPreauthorizedReturnInformationType extends AbstractStructBase
{
    /**
     * The ReturnEligibilityIndicator
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnEligibilityIndicator;
    /**
     * The ReturnExpirationDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnExpirationDate;
    /**
     * The ReturnRequestURL
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnRequestURL;
    /**
     * The OriginalTrackingNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OriginalTrackingNumber;
    /**
     * The ReturnTrackingNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnTrackingNumber;
    /**
     * Constructor method for PreauthorizedReturnInformationType
     * @uses Ups_trackPreauthorizedReturnInformationType::setReturnEligibilityIndicator()
     * @uses Ups_trackPreauthorizedReturnInformationType::setReturnExpirationDate()
     * @uses Ups_trackPreauthorizedReturnInformationType::setReturnRequestURL()
     * @uses Ups_trackPreauthorizedReturnInformationType::setOriginalTrackingNumber()
     * @uses Ups_trackPreauthorizedReturnInformationType::setReturnTrackingNumber()
     * @param string $returnEligibilityIndicator
     * @param string $returnExpirationDate
     * @param string $returnRequestURL
     * @param string $originalTrackingNumber
     * @param string $returnTrackingNumber
     */
    public function __construct($returnEligibilityIndicator = null, $returnExpirationDate = null, $returnRequestURL = null, $originalTrackingNumber = null, $returnTrackingNumber = null)
    {
        $this
            ->setReturnEligibilityIndicator($returnEligibilityIndicator)
            ->setReturnExpirationDate($returnExpirationDate)
            ->setReturnRequestURL($returnRequestURL)
            ->setOriginalTrackingNumber($originalTrackingNumber)
            ->setReturnTrackingNumber($returnTrackingNumber);
    }
    /**
     * Get ReturnEligibilityIndicator value
     * @return string|null
     */
    public function getReturnEligibilityIndicator()
    {
        return $this->ReturnEligibilityIndicator;
    }
    /**
     * Set ReturnEligibilityIndicator value
     * @param string $returnEligibilityIndicator
     * @return \Ups_track\UPStrackStruct\Ups_trackPreauthorizedReturnInformationType
     */
    public function setReturnEligibilityIndicator($returnEligibilityIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($returnEligibilityIndicator) && !is_string($returnEligibilityIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnEligibilityIndicator, true), gettype($returnEligibilityIndicator)), __LINE__);
        }
        $this->ReturnEligibilityIndicator = $returnEligibilityIndicator;
        return $this;
    }
    /**
     * Get ReturnExpirationDate value
     * @return string|null
     */
    public function getReturnExpirationDate()
    {
        return $this->ReturnExpirationDate;
    }
    /**
     * Set ReturnExpirationDate value
     * @param string $returnExpirationDate
     * @return \Ups_track\UPStrackStruct\Ups_trackPreauthorizedReturnInformationType
     */
    public function setReturnExpirationDate($returnExpirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($returnExpirationDate) && !is_string($returnExpirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnExpirationDate, true), gettype($returnExpirationDate)), __LINE__);
        }
        $this->ReturnExpirationDate = $returnExpirationDate;
        return $this;
    }
    /**
     * Get ReturnRequestURL value
     * @return string|null
     */
    public function getReturnRequestURL()
    {
        return $this->ReturnRequestURL;
    }
    /**
     * Set ReturnRequestURL value
     * @param string $returnRequestURL
     * @return \Ups_track\UPStrackStruct\Ups_trackPreauthorizedReturnInformationType
     */
    public function setReturnRequestURL($returnRequestURL = null)
    {
        // validation for constraint: string
        if (!is_null($returnRequestURL) && !is_string($returnRequestURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnRequestURL, true), gettype($returnRequestURL)), __LINE__);
        }
        $this->ReturnRequestURL = $returnRequestURL;
        return $this;
    }
    /**
     * Get OriginalTrackingNumber value
     * @return string|null
     */
    public function getOriginalTrackingNumber()
    {
        return $this->OriginalTrackingNumber;
    }
    /**
     * Set OriginalTrackingNumber value
     * @param string $originalTrackingNumber
     * @return \Ups_track\UPStrackStruct\Ups_trackPreauthorizedReturnInformationType
     */
    public function setOriginalTrackingNumber($originalTrackingNumber = null)
    {
        // validation for constraint: string
        if (!is_null($originalTrackingNumber) && !is_string($originalTrackingNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalTrackingNumber, true), gettype($originalTrackingNumber)), __LINE__);
        }
        $this->OriginalTrackingNumber = $originalTrackingNumber;
        return $this;
    }
    /**
     * Get ReturnTrackingNumber value
     * @return string|null
     */
    public function getReturnTrackingNumber()
    {
        return $this->ReturnTrackingNumber;
    }
    /**
     * Set ReturnTrackingNumber value
     * @param string $returnTrackingNumber
     * @return \Ups_track\UPStrackStruct\Ups_trackPreauthorizedReturnInformationType
     */
    public function setReturnTrackingNumber($returnTrackingNumber = null)
    {
        // validation for constraint: string
        if (!is_null($returnTrackingNumber) && !is_string($returnTrackingNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnTrackingNumber, true), gettype($returnTrackingNumber)), __LINE__);
        }
        $this->ReturnTrackingNumber = $returnTrackingNumber;
        return $this;
    }
}
