<?php

namespace Ups_track\UPStrackStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentActivityType UPStrackStruct
 * @package Ups_track
 * @subpackage Structs
 */
class Ups_trackShipmentActivityType extends AbstractStructBase
{
    /**
     * The ActivityLocation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_track\UPStrackStruct\Ups_trackAddressType
     */
    public $ActivityLocation;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The Time
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Time;
    /**
     * The Trailer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Trailer;
    /**
     * Constructor method for ShipmentActivityType
     * @uses Ups_trackShipmentActivityType::setActivityLocation()
     * @uses Ups_trackShipmentActivityType::setDescription()
     * @uses Ups_trackShipmentActivityType::setDate()
     * @uses Ups_trackShipmentActivityType::setTime()
     * @uses Ups_trackShipmentActivityType::setTrailer()
     * @param \Ups_track\UPStrackStruct\Ups_trackAddressType $activityLocation
     * @param string $description
     * @param string $date
     * @param string $time
     * @param string $trailer
     */
    public function __construct(\Ups_track\UPStrackStruct\Ups_trackAddressType $activityLocation = null, $description = null, $date = null, $time = null, $trailer = null)
    {
        $this
            ->setActivityLocation($activityLocation)
            ->setDescription($description)
            ->setDate($date)
            ->setTime($time)
            ->setTrailer($trailer);
    }
    /**
     * Get ActivityLocation value
     * @return \Ups_track\UPStrackStruct\Ups_trackAddressType|null
     */
    public function getActivityLocation()
    {
        return $this->ActivityLocation;
    }
    /**
     * Set ActivityLocation value
     * @param \Ups_track\UPStrackStruct\Ups_trackAddressType $activityLocation
     * @return \Ups_track\UPStrackStruct\Ups_trackShipmentActivityType
     */
    public function setActivityLocation(\Ups_track\UPStrackStruct\Ups_trackAddressType $activityLocation = null)
    {
        $this->ActivityLocation = $activityLocation;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Ups_track\UPStrackStruct\Ups_trackShipmentActivityType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \Ups_track\UPStrackStruct\Ups_trackShipmentActivityType
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get Time value
     * @return string|null
     */
    public function getTime()
    {
        return $this->Time;
    }
    /**
     * Set Time value
     * @param string $time
     * @return \Ups_track\UPStrackStruct\Ups_trackShipmentActivityType
     */
    public function setTime($time = null)
    {
        // validation for constraint: string
        if (!is_null($time) && !is_string($time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($time, true), gettype($time)), __LINE__);
        }
        $this->Time = $time;
        return $this;
    }
    /**
     * Get Trailer value
     * @return string|null
     */
    public function getTrailer()
    {
        return $this->Trailer;
    }
    /**
     * Set Trailer value
     * @param string $trailer
     * @return \Ups_track\UPStrackStruct\Ups_trackShipmentActivityType
     */
    public function setTrailer($trailer = null)
    {
        // validation for constraint: string
        if (!is_null($trailer) && !is_string($trailer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trailer, true), gettype($trailer)), __LINE__);
        }
        $this->Trailer = $trailer;
        return $this;
    }
}
