<?php

namespace Ups_track;

/**
 * Class which returns the class map definition
 * @package Ups_track
 */
class Ups_trackClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_track\\UPStrackStruct\\Ups_trackUPSSecurity',
            'UsernameToken' => '\\Ups_track\\UPStrackStruct\\Ups_trackUsernameToken',
            'ServiceAccessToken' => '\\Ups_track\\UPStrackStruct\\Ups_trackServiceAccessToken',
            'Errors' => '\\Ups_track\\UPStrackStruct\\Ups_trackErrors',
            'ErrorDetailType' => '\\Ups_track\\UPStrackStruct\\Ups_trackErrorDetailType',
            'ElementLevelInformationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackElementLevelInformationType',
            'ElementIdentifierType' => '\\Ups_track\\UPStrackStruct\\Ups_trackElementIdentifierType',
            'CodeType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCodeType',
            'AdditionalInfoType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAdditionalInfoType',
            'AdditionalCodeDescType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAdditionalCodeDescType',
            'LocationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackLocationType',
            'ClientInformationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackClientInformationType',
            'Property' => '\\Ups_track\\UPStrackStruct\\Ups_trackProperty',
            'RequestType' => '\\Ups_track\\UPStrackStruct\\Ups_trackRequestType',
            'TransactionReferenceType' => '\\Ups_track\\UPStrackStruct\\Ups_trackTransactionReferenceType',
            'ResponseType' => '\\Ups_track\\UPStrackStruct\\Ups_trackResponseType',
            'CodeDescriptionType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCodeDescriptionType',
            'DetailType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDetailType',
            'TrackRequest' => '\\Ups_track\\UPStrackStruct\\Ups_trackTrackRequest',
            'AddressRequestType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAddressRequestType',
            'RefShipmentType' => '\\Ups_track\\UPStrackStruct\\Ups_trackRefShipmentType',
            'PickupDateRangeType' => '\\Ups_track\\UPStrackStruct\\Ups_trackPickupDateRangeType',
            'ReferenceNumberType' => '\\Ups_track\\UPStrackStruct\\Ups_trackReferenceNumberType',
            'RequestTransactionReferenceType' => '\\Ups_track\\UPStrackStruct\\Ups_trackRequestTransactionReferenceType',
            'ShipToRequestType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipToRequestType',
            'ShipFromRequestType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipFromRequestType',
            'TrackResponse' => '\\Ups_track\\UPStrackStruct\\Ups_trackTrackResponse',
            'ActivityLocationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackActivityLocationType',
            'TransportFacilityType' => '\\Ups_track\\UPStrackStruct\\Ups_trackTransportFacilityType',
            'ActivityType' => '\\Ups_track\\UPStrackStruct\\Ups_trackActivityType',
            'NextScheduleActivityType' => '\\Ups_track\\UPStrackStruct\\Ups_trackNextScheduleActivityType',
            'AddressType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAddressType',
            'AmountType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAmountType',
            'CommonCodeDescriptionType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCommonCodeDescriptionType',
            'CODType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCODType',
            'CODStatusType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCODStatusType',
            'DeliveryDetailType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDeliveryDetailType',
            'ImageFormatType' => '\\Ups_track\\UPStrackStruct\\Ups_trackImageFormatType',
            'MessageType' => '\\Ups_track\\UPStrackStruct\\Ups_trackMessageType',
            'NumberOfPackagingUnitType' => '\\Ups_track\\UPStrackStruct\\Ups_trackNumberOfPackagingUnitType',
            'PackageType' => '\\Ups_track\\UPStrackStruct\\Ups_trackPackageType',
            'RedirectType' => '\\Ups_track\\UPStrackStruct\\Ups_trackRedirectType',
            'DeliveryDateUnavailableType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDeliveryDateUnavailableType',
            'PackageAddressType' => '\\Ups_track\\UPStrackStruct\\Ups_trackPackageAddressType',
            'ProductCodeDescriptionType' => '\\Ups_track\\UPStrackStruct\\Ups_trackProductCodeDescriptionType',
            'PODLetterType' => '\\Ups_track\\UPStrackStruct\\Ups_trackPODLetterType',
            'ResponseTransactionReferenceType' => '\\Ups_track\\UPStrackStruct\\Ups_trackResponseTransactionReferenceType',
            'ServiceType' => '\\Ups_track\\UPStrackStruct\\Ups_trackServiceType',
            'ShipmentReferenceNumberType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipmentReferenceNumberType',
            'ShipmentType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipmentType',
            'ShipmentAddressType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipmentAddressType',
            'AppointmentType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAppointmentType',
            'CodeDescriptionValueType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCodeDescriptionValueType',
            'AdditionalCodeDescriptionValueType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAdditionalCodeDescriptionValueType',
            'SignatureImageType' => '\\Ups_track\\UPStrackStruct\\Ups_trackSignatureImageType',
            'StatusType' => '\\Ups_track\\UPStrackStruct\\Ups_trackStatusType',
            'UnitOfMeasurementType' => '\\Ups_track\\UPStrackStruct\\Ups_trackUnitOfMeasurementType',
            'VolumeType' => '\\Ups_track\\UPStrackStruct\\Ups_trackVolumeType',
            'WeightType' => '\\Ups_track\\UPStrackStruct\\Ups_trackWeightType',
            'DateTimeType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDateTimeType',
            'ServiceCenterType' => '\\Ups_track\\UPStrackStruct\\Ups_trackServiceCenterType',
            'ServiceOptionType' => '\\Ups_track\\UPStrackStruct\\Ups_trackServiceOptionType',
            'DocumentType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDocumentType',
            'ShipmentActivityType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipmentActivityType',
            'OriginPortDetailType' => '\\Ups_track\\UPStrackStruct\\Ups_trackOriginPortDetailType',
            'DestinationPortDetailType' => '\\Ups_track\\UPStrackStruct\\Ups_trackDestinationPortDetailType',
            'CarrierActivityInformationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackCarrierActivityInformationType',
            'ShipperAccountInfoType' => '\\Ups_track\\UPStrackStruct\\Ups_trackShipperAccountInfoType',
            'AlternateTrackingInfoType' => '\\Ups_track\\UPStrackStruct\\Ups_trackAlternateTrackingInfoType',
            'PreauthorizedReturnInformationType' => '\\Ups_track\\UPStrackStruct\\Ups_trackPreauthorizedReturnInformationType',
        );
    }
}
